diff -uNr mythtv-0.21/libs/libmyth/mythcontext.cpp mythtv/libs/libmyth/mythcontext.cpp
--- mythtv-0.21/libs/libmyth/mythcontext.cpp	2008-03-07 01:50:20.000000000 +0100
+++ mythtv/libs/libmyth/mythcontext.cpp	2009-02-09 09:59:19.000000000 +0100
@@ -3690,7 +3729,7 @@
     return MYTH_SCHEMA_UPGRADE;
 }
 
-bool MythContext::TestPopupVersion(const QString &name, 
+bool MythContext::TestPopupVersion(const QString &name,
                                    const QString &libversion,
                                    const QString &pluginversion)
 {
@@ -3704,7 +3743,7 @@
                   "make distclean.";
 
     if (GetMainWindow() && !d->disablelibrarypopup)
-    {    
+    {
         DialogBox *dlg = new DialogBox(gContext->GetMainWindow(), err);
         dlg->AddButton("OK");
         dlg->exec();
@@ -3808,7 +3847,7 @@
             {
                 if (0 < d->lastLogCounts[module])
                 {
-                    LogEntry(module, priority, 
+                    LogEntry(module, priority,
                              QString("Last message repeated %1 times")
                                     .arg(d->lastLogCounts[module]),
                              d->lastLogStrings[module]);
@@ -3838,7 +3877,7 @@
         if (d->m_logmaxcount > 0)
         {
             query.prepare("SELECT logid FROM mythlog WHERE "
-                          "module= :MODULE ORDER BY logdate ASC ;"); 
+                          "module= :MODULE ORDER BY logdate ASC ;");
             query.bindValue(":MODULE", module);
             if (!query.exec() || !query.isActive())
             {
@@ -3848,7 +3887,7 @@
             {
                 howmany = query.size();
                 if (howmany > d->m_logmaxcount)
-                { 
+                {
                     MSqlQuery delquery(MSqlQuery::InitCon());
                     while (howmany > d->m_logmaxcount)
                     {
@@ -3857,7 +3896,7 @@
                         delquery.prepare("DELETE FROM mythlog WHERE "
                                          "logid= :LOGID ;");
                         delquery.bindValue(":LOGID", logid);
-                        
+
                         if (!delquery.exec() || !delquery.isActive())
                         {
                             MythContext::DBError("DelLogEntry#2", delquery);
@@ -3911,22 +3950,22 @@
 {
     bool ret = true;
     DatabaseParams cur_params = GetDatabaseParams();
-    
+
     // only rewrite file if it has changed
-    if (params.dbHostName   != cur_params.dbHostName          || 
-        params.dbHostPing   != cur_params.dbHostPing          || 
-        params.dbPort       != cur_params.dbPort              || 
-        params.dbUserName   != cur_params.dbUserName          || 
-        params.dbPassword   != cur_params.dbPassword          || 
-        params.dbName       != cur_params.dbName              || 
-        params.dbType       != cur_params.dbType              || 
-        params.localEnabled != cur_params.localEnabled        || 
-        params.wolEnabled   != cur_params.wolEnabled          || 
-        (params.localEnabled && 
-         (params.localHostName != cur_params.localHostName))  || 
-        (params.wolEnabled && 
-         (params.wolReconnect  != cur_params.wolReconnect || 
-          params.wolRetry      != cur_params.wolRetry     || 
+    if (params.dbHostName   != cur_params.dbHostName          ||
+        params.dbHostPing   != cur_params.dbHostPing          ||
+        params.dbPort       != cur_params.dbPort              ||
+        params.dbUserName   != cur_params.dbUserName          ||
+        params.dbPassword   != cur_params.dbPassword          ||
+        params.dbName       != cur_params.dbName              ||
+        params.dbType       != cur_params.dbType              ||
+        params.localEnabled != cur_params.localEnabled        ||
+        params.wolEnabled   != cur_params.wolEnabled          ||
+        (params.localEnabled &&
+         (params.localHostName != cur_params.localHostName))  ||
+        (params.wolEnabled &&
+         (params.wolReconnect  != cur_params.wolReconnect ||
+          params.wolRetry      != cur_params.wolRetry     ||
           params.wolCommand    != cur_params.wolCommand)))
     {
         ret = d->WriteSettingsFile(params, true);
diff -uNr mythtv-0.21/libs/libmyth/mythmedia.cpp mythtv/libs/libmyth/mythmedia.cpp
--- mythtv-0.21/libs/libmyth/mythmedia.cpp	2008-02-12 22:41:50.000000000 +0100
+++ mythtv/libs/libmyth/mythmedia.cpp	2009-04-02 08:13:16.000000000 +0200
@@ -288,13 +288,20 @@
 
 bool MythMediaDevice::isSameDevice(const QString &path)
 {
+#ifdef Q_OS_MAC
+    // The caller may be using a raw device instead of the BSD 'leaf' name
+    if (path == "/dev/r" + m_DevicePath)
+        return true;
+#endif
+
     return (path == m_DevicePath);
 }
 
 void MythMediaDevice::setSpeed(int speed)
 {
-    (void)speed;
-    return;
+    VERBOSE(VB_MEDIA,
+            QString("Cannot setSpeed(%1) for device %2 - not implemented.")
+            .arg(speed).arg(m_DevicePath));
 }
 
 MediaError MythMediaDevice::lock() 
diff -uNr mythtv-0.21/libs/libmyth/mythmediamonitor.cpp mythtv/libs/libmyth/mythmediamonitor.cpp
--- mythtv-0.21/libs/libmyth/mythmediamonitor.cpp	2008-01-11 07:16:25.000000000 +0100
+++ mythtv/libs/libmyth/mythmediamonitor.cpp	2009-04-02 08:13:16.000000000 +0200
@@ -15,6 +15,7 @@
 
 // MythTV headers
 #include "mythmediamonitor.h"
+#include "mythcdrom.h"
 #include "mythcontext.h"
 #include "mythdialogs.h"
 #include "mythconfig.h"
@@ -81,8 +82,13 @@
         {
             pMedia->setSpeed(speed);
             mon->Unlock(pMedia);
+            return;
         }
     }
+
+    MythCDROM *cd = MythCDROM::get(NULL, device, false, false);
+    cd->setSpeed(device, speed);
+    delete cd;
 }
 
 // When ejecting one of multiple devices, present a nice name to the user
diff -uNr mythtv-0.21/libs/libmyth/screensaver-x11.cpp mythtv/libs/libmyth/screensaver-x11.cpp
--- mythtv-0.21/libs/libmyth/screensaver-x11.cpp	2007-12-21 18:06:10.000000000 +0100
+++ mythtv/libs/libmyth/screensaver-x11.cpp	2008-12-03 05:36:29.000000000 +0100
@@ -1,5 +1,6 @@
 #define QT_CLEAN_NAMESPACE // no qt 1.x compatability, INT32 conflicts with X
 #include "screensaver-x11.h"
+#include <qdatetime.h>
 #include <qtimer.h>
 
 #include <X11/Xlib.h>
@@ -135,10 +136,19 @@
 
     void ResetScreenSaver()
     {
-        if (m_xscreensaverRunning)
-            myth_system("xscreensaver-command -deactivate >&- 2>&- &");
-        else
-            myth_system("gnome-screensaver-command --poke >&- 2>&- &");
+        if (IsScreenSaverRunning())
+        {
+            QDateTime current_time = QDateTime::currentDateTime ();
+            if ((!m_last_deactivated.isValid()) ||
+                (m_last_deactivated.secsTo(current_time) > 30))
+            {
+                if (m_xscreensaverRunning)
+                    myth_system("xscreensaver-command -deactivate >&- 2>&- &");
+                else if (m_gscreensaverRunning)
+                    myth_system("gnome-screensaver-command --poke >&- 2>&- &");
+                m_last_deactivated = current_time;
+            }
+        }
     }
 
   private:
@@ -162,6 +172,8 @@
     int m_timeoutInterval;
     QTimer *m_resetTimer;
 
+    QDateTime m_last_deactivated;
+
     ScreenSaverState m_state;
 };
 
diff -uNr mythtv-0.21/libs/libmyth/storagegroup.cpp mythtv/libs/libmyth/storagegroup.cpp
--- mythtv-0.21/libs/libmyth/storagegroup.cpp	2008-02-15 01:30:26.000000000 +0100
+++ mythtv/libs/libmyth/storagegroup.cpp	2008-07-06 08:27:55.000000000 +0200
@@ -394,6 +394,9 @@
         if (result == SGPopup_CANCEL)
             return;
 
+        if (name == "")
+            return;
+
         if (name.right(1) != "/")
             name.append("/");
 
diff -uNr mythtv-0.21/libs/libmyth/util.cpp mythtv/libs/libmyth/util.cpp
--- mythtv-0.21/libs/libmyth/util.cpp	2008-02-24 16:19:20.000000000 +0100
+++ mythtv/libs/libmyth/util.cpp	2009-04-19 23:30:15.000000000 +0200
@@ -24,6 +24,9 @@
 #   include <sys/sysinfo.h>
 # else
 #   include <sys/param.h>
+#   ifdef __FreeBSD__ 
+#     include <sys/mount.h> 
+#   endif
 #   ifdef CONFIG_CYGWIN
 #     include <sys/statfs.h>
 #   else // if !CONFIG_CYGWIN
@@ -62,6 +65,8 @@
 #include "jsmenuevent.h"
 #endif
 
+#include "mythconfig.h" // for CONFIG_DARWIN
+
 /** \fn mythCurrentDateTime()
  *  \brief Returns the current QDateTime object, stripped of its msec component
  */
@@ -293,10 +298,11 @@
                     return GENERIC_EXIT_NOT_OK;
                 }
 
+                qApp->processEvents();
+
                 if (res > 0)
                     return WEXITSTATUS(status);
 
-                qApp->processEvents();
                 usleep(100000);
             }
         }
@@ -955,3 +961,18 @@
     return approx_size;
 #endif
 }
+
+bool IsPulseAudioRunning(void)
+{
+#if defined(CONFIG_DARWIN) || (__FreeBSD__) || defined(__OpenBSD__)
+    const char *command = "ps -ax | grep -i pulseaudio | grep -v grep > /dev/null";
+#else
+    const char *command = "ps -ae | grep pulseaudio > /dev/null";
+#endif
+    bool res = myth_system(command,
+                           MYTH_SYSTEM_DONT_BLOCK_LIRC |
+                           MYTH_SYSTEM_DONT_BLOCK_JOYSTICK_MENU);
+    return !res;
+}
+
+/* vim: set expandtab tabstop=4 shiftwidth=4: */
diff -uNr mythtv-0.21/libs/libmyth/util.h mythtv/libs/libmyth/util.h
--- mythtv-0.21/libs/libmyth/util.h	2008-02-19 12:43:05.000000000 +0100
+++ mythtv/libs/libmyth/util.h	2009-04-19 23:30:15.000000000 +0200
@@ -84,6 +84,9 @@
 
 MPUBLIC double MythGetPixelAspectRatio(void);
 
+/// Is A/V Sync destruction daemon is running on this host?
+MPUBLIC bool IsPulseAudioRunning(void);
+
 // CPU Tick timing function
 #ifdef MMX
 #ifdef _WIN32
diff -uNr mythtv-0.21/libs/libmythdvdnav/libmythdvdnav.pro mythtv/libs/libmythdvdnav/libmythdvdnav.pro
--- mythtv-0.21/libs/libmythdvdnav/libmythdvdnav.pro	2007-12-11 15:56:01.000000000 +0100
+++ mythtv/libs/libmythdvdnav/libmythdvdnav.pro	2008-06-04 06:05:51.000000000 +0200
@@ -38,3 +38,5 @@
 }
 
 mingw:DEFINES += STDC_HEADERS
+
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythdvdnav/nav_read.c mythtv/libs/libmythdvdnav/nav_read.c
--- mythtv-0.21/libs/libmythdvdnav/nav_read.c	2006-02-15 08:18:03.000000000 +0100
+++ mythtv/libs/libmythdvdnav/nav_read.c	2008-06-21 17:07:33.000000000 +0200
@@ -353,6 +353,8 @@
   /* Asserts */
 
   /* dsi dsi gi */
+#ifdef LOG_DEBUG
   CHECK_VALUE(dsi->dsi_gi.zero1 == 0);
+#endif
 }
 
diff -uNr mythtv-0.21/libs/libmythdvdnav/searching.c mythtv/libs/libmythdvdnav/searching.c
--- mythtv-0.21/libs/libmythdvdnav/searching.c	2008-02-19 14:38:46.000000000 +0100
+++ mythtv/libs/libmythdvdnav/searching.c	2008-07-14 00:54:26.000000000 +0200
@@ -478,15 +478,11 @@
   if (menu == DVD_MENU_Escape) menu = DVD_MENU_Root;
 
   if (vm_jump_menu(try_vm, menu) && !try_vm->stopped) {
-    vm_get_next_cell(try_vm);
-    if (!try_vm->pgcN_invalid)
-    {
-      vm_free_copy(try_vm);
-      pthread_mutex_unlock(&this->vm_lock);
-      return DVDNAV_STATUS_OK;
-    }
+    vm_free_copy(try_vm);
+    pthread_mutex_unlock(&this->vm_lock);
+    return DVDNAV_STATUS_OK;
   }
-  
+
   vm_free_copy(try_vm);
   printerr("No such menu or menu not reachable.");
   pthread_mutex_unlock(&this->vm_lock);
@@ -495,7 +491,7 @@
 
 dvdnav_status_t dvdnav_menu_call(dvdnav_t *this, DVDMenuID_t menu) {
   vm_t *try_vm;
-  
+
   if(!this) {
     printerr("Passed a NULL pointer.");
     return DVDNAV_STATUS_ERR;
@@ -660,7 +656,7 @@
     return DVDNAV_STATUS_ERR;
   }
 
-  uint32_t cur_vobu, new_vobu, start, offset;
+  uint32_t cur_vobu, new_vobu = 0, start, offset;
   uint32_t first_cell_nr, last_cell_nr, cell_nr;
   cell_playback_t *cell;
   int i, length, scan_admap;
@@ -690,7 +686,7 @@
   {
     dsi = dvdnav_get_current_nav_dsi(this);
     if (length > 0) {
-      for (i = 1; i <= 19; i++) {
+      for (i = 0; i < 19; i++) {
         if (stime[i]/2.0 <= length/2.0) {
           offset = dsi->vobu_sri.fwda[i];
           if (offset >> 31) {
@@ -708,16 +704,14 @@
         }
       }
     } else {
-      for (i = 1; i <= 19; i++) {
+      for (i = 0; i < 19; i++) {
         if (stime[18 - i]/2.0 >= abs(length)/2.0)
         {
           offset = dsi->vobu_sri.bwda[i];
           if (offset >> 31) {
             new_vobu = cur_vobu - (offset & 0xffff);
           } else {
-            if (cell_nr == first_cell_nr) {
-              new_vobu = 0;
-            } else {
+            if (cell_nr != first_cell_nr) {
               cell_nr--;
               offset = state->pgc->cell_playback[cell_nr].last_sector;
               scan_admap = 1;
diff -uNr mythtv-0.21/libs/libmythfreemheg/Actions.cpp mythtv/libs/libmythfreemheg/Actions.cpp
--- mythtv-0.21/libs/libmythfreemheg/Actions.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/Actions.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Actions.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -93,8 +93,8 @@
         case C_GET_ENTRY_POINT: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // EntryField
         case C_GET_FILL_COLOUR: pAction = new MHGetFillColour; break;
         case C_GET_FIRST_ITEM: pAction = new MHGetFirstItem; break;
-        case C_GET_HIGHLIGHT_STATUS: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// ?
-        case C_GET_INTERACTION_STATUS: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// ?
+        case C_GET_HIGHLIGHT_STATUS: pAction = new MHGetHighlightStatus; break;
+        case C_GET_INTERACTION_STATUS: pAction = new MHGetInteractionStatus; break;
         case C_GET_ITEM_STATUS: pAction = new MHGetItemStatus; break;
         case C_GET_LABEL: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// PushButton
         case C_GET_LAST_ANCHOR_FIRED: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// HyperText
@@ -104,11 +104,11 @@
         case C_GET_LIST_ITEM: pAction = new MHGetListItem; break;
         case C_GET_LIST_SIZE: pAction = new MHGetListSize; break;
         case C_GET_OVERWRITE_MODE: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// ?
-        case C_GET_PORTION: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// Slider
+        case C_GET_PORTION: pAction = new MHGetPortion; break;
         case C_GET_POSITION: pAction = new MHGetPosition; break;
         case C_GET_RUNNING_STATUS: pAction = new MHGetRunningStatus; break;
         case C_GET_SELECTION_STATUS: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// ?
-        case C_GET_SLIDER_VALUE: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// Slider
+        case C_GET_SLIDER_VALUE: pAction = new MHGetSliderValue; break;
         case C_GET_TEXT_CONTENT: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break;// Text
         case C_GET_TEXT_DATA: pAction = new MHGetTextData; break;
         case C_GET_TOKEN_POSITION: pAction = new MHGetTokenPosition; break;
@@ -145,24 +145,24 @@
         case C_SET_FILL_COLOUR: pAction = new MHSetFillColour; break;
         case C_SET_FIRST_ITEM: pAction = new MHSetFirstItem; break;
         case C_SET_FONT_REF: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // Text
-        case C_SET_HIGHLIGHT_STATUS: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // ?
-        case C_SET_INTERACTION_STATUS: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // ?
+        case C_SET_HIGHLIGHT_STATUS: pAction = new MHSetHighlightStatus; break;
+        case C_SET_INTERACTION_STATUS: pAction = new MHSetInteractionStatus; break;
         case C_SET_LABEL: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // PushButton
         case C_SET_LINE_COLOUR: pAction = new MHSetLineColour; break;
         case C_SET_LINE_STYLE: pAction = new MHSetLineStyle; break;
         case C_SET_LINE_WIDTH: pAction = new MHSetLineWidth; break;
         case C_SET_OVERWRITE_MODE: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // EntryField
         case C_SET_PALETTE_REF: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // Visible
-        case C_SET_PORTION: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // Slider
+        case C_SET_PORTION: pAction = new MHSetPortion; break;
         case C_SET_POSITION: pAction = new MHSetPosition; break;
-        case C_SET_SLIDER_VALUE: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // Slider
+        case C_SET_SLIDER_VALUE: pAction = new MHSetSliderValue; break;
         case C_SET_SPEED: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // ?
         case C_SET_TIMER: pAction = new MHSetTimer; break;
         case C_SET_TRANSPARENCY: pAction = new MHSetTransparency; break;
         case C_SET_VARIABLE: pAction = new MHSetVariable; break;
         case C_SET_VOLUME: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // ?
         case C_SPAWN: pAction = new MHSpawn; break;
-        case C_STEP: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // Slider
+        case C_STEP: pAction = new MHStep; break;
         case C_STOP: pAction = new MHStop; break;
         case C_STORE_PERSISTENT: pAction = new MHPersistent(":StorePersistent", false); break;
         case C_SUBTRACT: pAction = new MHSubtract; break;
@@ -184,7 +184,7 @@
         case C_SET_FOCUS_POSITION: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // HyperText
         case C_SET_BITMAP_DECODE_OFFSET: pAction = new MHSetBitmapDecodeOffset; break;
         case C_GET_BITMAP_DECODE_OFFSET: pAction = new MHGetBitmapDecodeOffset; break;
-        case C_SET_SLIDER_PARAMETERS: pAction = new MHUnimplementedAction(pElemAction->GetTagNo()); break; // ?
+        case C_SET_SLIDER_PARAMETERS: pAction = new MHSetSliderParameters; break;
 
         default:
             MHLOG(MHLogWarning, QString("Unknown action %1").arg(pElemAction->GetTagNo()));
diff -uNr mythtv-0.21/libs/libmythfreemheg/BaseActions.cpp mythtv/libs/libmythfreemheg/BaseActions.cpp
--- mythtv-0.21/libs/libmythfreemheg/BaseActions.cpp	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/BaseActions.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* BaseActions.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -87,6 +87,26 @@
     m_ResultVar2.Initialise(p->GetArgN(2), engine);
 }
 
+void MHActionInt3::Initialise(MHParseNode *p, MHEngine *engine)
+{
+    MHElemAction::Initialise(p, engine);
+    m_Argument1.Initialise(p->GetArgN(1), engine);
+    m_Argument2.Initialise(p->GetArgN(2), engine);
+    m_Argument3.Initialise(p->GetArgN(3), engine);
+}
+
+void MHActionInt3::PrintArgs(FILE *fd, int /*nTabs*/) const
+{
+    m_Argument1.PrintMe(fd, 0);
+    m_Argument2.PrintMe(fd, 0);
+    m_Argument3.PrintMe(fd, 0);
+}
+
+void MHActionInt3::Perform(MHEngine *engine)
+{
+    CallAction(engine, Target(engine), m_Argument1.GetValue(engine), m_Argument2.GetValue(engine), m_Argument3.GetValue(engine));
+}
+
 void MHActionInt4::Initialise(MHParseNode *p, MHEngine *engine)
 {
     MHElemAction::Initialise(p, engine);
@@ -160,3 +180,15 @@
 {
     CallAction(engine, Target(engine), engine->FindObject(m_ResultVar1), engine->FindObject(m_ResultVar2));
 }
+
+void MHActionBool::Initialise(MHParseNode *p, MHEngine *engine)
+{
+    MHElemAction::Initialise(p, engine);
+    m_Argument.Initialise(p->GetArgN(1), engine);
+}
+
+
+void MHActionBool::Perform(MHEngine *engine)
+{
+    CallAction(engine, Target(engine), m_Argument.GetValue(engine));
+}
diff -uNr mythtv-0.21/libs/libmythfreemheg/BaseActions.h mythtv/libs/libmythfreemheg/BaseActions.h
--- mythtv-0.21/libs/libmythfreemheg/BaseActions.h	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/BaseActions.h	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* BaseActions.h
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -73,6 +73,19 @@
     MHGenericInteger m_Argument1, m_Argument2;
 };
 
+// Base class for actions with three integers.  Used for SetSliderParameters
+class MHActionInt3: public MHElemAction
+{
+public:
+    MHActionInt3(const char *name): MHElemAction(name) {}
+    virtual void Initialise(MHParseNode *p, MHEngine *engine);
+    virtual void PrintArgs(FILE *fd, int nTabs) const;
+    virtual void Perform(MHEngine *engine);
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, int nArg1, int nArg2, int nArg3) = 0;
+protected:
+    MHGenericInteger m_Argument1, m_Argument2, m_Argument3;
+};
+
 // Base class for actions with four integers.  Used in the DynamicLineArt class
 class MHActionInt4: public MHElemAction
 {
@@ -139,4 +152,17 @@
 };
 
 
+// Base class for actions with a single boolean argument.
+class MHActionBool: public MHElemAction
+{
+public:
+    MHActionBool(const char *name): MHElemAction(name) {}
+    virtual void Initialise(MHParseNode *p, MHEngine *engine);
+    virtual void PrintArgs(FILE *fd, int) const { m_Argument.PrintMe(fd, 0); }
+    virtual void Perform(MHEngine *engine);
+    virtual void CallAction(MHEngine *engine, MHRoot *pTarget, bool fArg) = 0;
+protected:
+    MHGenericBoolean m_Argument;
+};
+
 #endif
diff -uNr mythtv-0.21/libs/libmythfreemheg/Bitmap.cpp mythtv/libs/libmythfreemheg/Bitmap.cpp
--- mythtv-0.21/libs/libmythfreemheg/Bitmap.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/Bitmap.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Bitmap.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -111,7 +111,10 @@
     if (nCHook == 4) { // PNG.
         m_pContent->CreateFromPNG(data, length);
     }
-    else if (nCHook == 2) { // MPEG I-frame.
+    // CHook 5 seems to be used by the BBC on Freesat for an MPEG I-frame for the
+    // background but enabling it here results in it overlaying the video.
+    // Presumably it is not simply the same as CHook 2.
+    else if (nCHook == 2 /* ||nCHook == 5 */) { // MPEG I-frame.
         m_pContent->CreateFromMPEG(data, length);
     }
 
diff -uNr mythtv-0.21/libs/libmythfreemheg/Engine.cpp mythtv/libs/libmythfreemheg/Engine.cpp
--- mythtv-0.21/libs/libmythfreemheg/Engine.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/Engine.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Engine.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -31,6 +31,7 @@
 #include "ASN1Codes.h"
 #include "Logging.h"
 #include "freemheg.h"
+#include "Visible.h"  // For MHInteractible
 
 #include <stdio.h>
 #include <stdlib.h>
@@ -50,6 +51,7 @@
     m_ExternContentTable.setAutoDelete(true);
 
     m_fBooting = true;
+    m_Interacting = 0;
 }
 
 MHEngine::~MHEngine()
@@ -307,6 +309,7 @@
         pApp->m_pCurrentScene = NULL;
     }
 
+    m_Interacting = 0;
 
     // Switch to the new scene.
     CurrentApp()->m_pCurrentScene = (MHScene*) pProgram;
@@ -604,7 +607,29 @@
 {
     MHScene *pScene = CurrentScene();
     if (! pScene) return;
-    EventTriggered(pScene, EventUserInput, nCode);
+    // Various keys generate engine events as well as user events.
+    // These are generated before the user events and even if there
+    // is an interactible.
+    switch (nCode)
+    {
+    case 104:
+    case 105: // Text key
+        EventTriggered(pScene, EventEngineEvent, 4);
+        break;
+    case 16: // Text Exit/Cancel key
+    case 100: // Red
+    case 101: // Green
+    case 102: // Yellow
+    case 103: // Blue
+        EventTriggered(pScene, EventEngineEvent, nCode);
+        break;
+    }
+
+    // If we are interacting with an interactible send the key
+    // there otherwise generate a user event.
+    if (m_Interacting)
+        m_Interacting->KeyEvent(this, nCode);
+    else EventTriggered(pScene, EventUserInput, nCode);
 }
 
 // Called by an ingredient wanting external content.
diff -uNr mythtv-0.21/libs/libmythfreemheg/Engine.h mythtv/libs/libmythfreemheg/Engine.h
--- mythtv-0.21/libs/libmythfreemheg/Engine.h	2006-04-06 22:23:34.000000000 +0200
+++ mythtv/libs/libmythfreemheg/Engine.h	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Engine.h
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -63,6 +63,8 @@
     MHIngredient *m_pRequester; 
 };
 
+class MHInteractible;
+
 class MHEngine: public MHEG {
 public:
     MHEngine(MHContext *context);
@@ -148,6 +150,10 @@
 
     static const char *MHEGEngineProviderIdString;
 
+    // Interaction: Set if an Interactible has the focus and is receiving key presses.
+    MHInteractible *GetInteraction(void) { return m_Interacting; }
+    void SetInteraction(MHInteractible *p) { m_Interacting = p; }
+
 protected:
     void CheckLinks(const MHObjectRef &sourceRef, enum EventType ev, const MHUnion &un);
     MHGroup *ParseProgram(QByteArray &text);
@@ -187,6 +193,8 @@
 
     MHContext       *m_Context; // Pointer to the context providing drawing and other operations
     bool            m_fBooting;
+
+    MHInteractible  *m_Interacting; // Set to current interactive object if any.
 };
 
 #endif
diff -uNr mythtv-0.21/libs/libmythfreemheg/libmythfreemheg.pro mythtv/libs/libmythfreemheg/libmythfreemheg.pro
--- mythtv-0.21/libs/libmythfreemheg/libmythfreemheg.pro	2007-12-12 03:53:59.000000000 +0100
+++ mythtv/libs/libmythfreemheg/libmythfreemheg.pro	2008-06-04 06:05:51.000000000 +0200
@@ -24,4 +24,4 @@
 
 LIBS += $$EXTRA_LIBS
 
-mingw:  target.path = $${PREFIX}/bin
+include ( ../libs-targetfix.pro )
diff -uNr mythtv-0.21/libs/libmythfreemheg/Link.cpp mythtv/libs/libmythfreemheg/Link.cpp
--- mythtv-0.21/libs/libmythfreemheg/Link.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/Link.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* Link.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -76,7 +76,7 @@
     m_LinkEffect.Initialise(pLinkEffect, engine);
 }
 
-static char *rchEventType[] =
+static const char *rchEventType[] =
 {
     "IsAvailable",
     "ContentAvailable",
diff -uNr mythtv-0.21/libs/libmythfreemheg/ParseText.cpp mythtv/libs/libmythfreemheg/ParseText.cpp
--- mythtv-0.21/libs/libmythfreemheg/ParseText.cpp	2007-01-05 16:26:11.000000000 +0100
+++ mythtv/libs/libmythfreemheg/ParseText.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -1,6 +1,6 @@
 /* ParseText.cpp
 
-   Copyright (C)  David C. J. Matthews 2004  dm at prolingua.co.uk
+   Copyright (C)  David C. J. Matthews 2004, 2008  dm at prolingua.co.uk
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
@@ -536,6 +536,10 @@
                 if (m_nInt > 0) return;
                 m_nInt = MHText::GetStartCorner(buff);
                 if (m_nInt > 0) return;
+                m_nInt = MHSlider::GetOrientation(buff);
+                if (m_nInt > 0) return;
+                m_nInt = MHSlider::GetStyle(buff);
+                if (m_nInt > 0) return;
 
                 // Check the colour table.  If it's there generate a string containing the colour info.
                 for (int i = 0; i < (int)(sizeof(colourTable)/sizeof(colourTable[0])); i++) {
diff -uNr mythtv-0.21/libs/libmythfreemheg/Programs.cpp mythtv/libs/libmythfreemheg/Programs.cpp
--- mythtv-0.21/libs/libmythfreemheg/Programs.cpp	2007-03-29 21:44:23.000000000 +0200
+++ mythtv/libs/libmythfreemheg/Programs.cpp	2008-12-11 23:59:27.000000000 +0100
@@ -30,7 +30,11 @@
 #include "freemheg.h"
 
 #include <sys/timeb.h>
+#ifdef __FreeBSD__ 
+#include <sys/time.h> 
+#else
 #include <time.h>
+#endif
 
 #include "../../config.h"
 
@@ -486,7 +490,31 @@
         }
 
         else if (m_Name.Equal("DBG")) { // Debug - optional
-            MHERROR("Debug ResidentProgram is not implemented");
+            QString message = "DEBUG: ";
+            for (int i = 0; i < args.Size(); i++) {
+                MHUnion un;
+                un.GetValueFrom(*(args.GetAt(i)), engine);
+                switch (un.m_Type) {
+                case MHUnion::U_Int:
+                    message.append(QString("%1").arg(un.m_nIntVal));
+                    break;
+                case MHParameter::P_Bool:
+                    message.append(un.m_fBoolVal ? "True" : "False");
+                    break;
+                case MHParameter::P_String:
+                    message.append(QString::fromUtf8((const char *)un.m_StrVal.Bytes(), un.m_StrVal.Size()));
+                    break;
+                case MHParameter::P_ObjRef:
+                    message.append(un.m_ObjRefVal.Printable());
+                    break;
+                case MHParameter::P_ContentRef:
+                    message.append(un.m_ContentRefVal.Printable());
+                    break;
+                case MHParameter::P_Null:
+                    break;
+                }
+            }
+            MHLOG(MHLogNotifications, message);
         }
 
         else {
